---
title: 'Window: hashchange event'
slug: Web/API/Window/hashchange_event
tags:
  - API
  - Event
  - HTML DOM
  - Reference
  - Window
---
<div>{{APIRef}}</div>

<p>The <strong><code>hashchange</code></strong> event is fired when the fragment identifier of the URL has changed (the part of the URL beginning with and following the <code>#</code> symbol).</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("HashChangeEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler</th>
   <td>{{domxref("WindowEventHandlers/onhashchange", "onhashchange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>You can use the <code>hashchange</code> event in an {{domxref("EventTarget/addEventListener", "addEventListener")}} method:</p>

<pre class="brush:js">window.addEventListener('hashchange', function() {
  console.log('The hash has changed!')
}, false);</pre>

<p>Or use the <code>onhashchange</code> event handler property:</p>

<pre class="brush: js">function locationHashChanged() {
  if (location.hash === '#cool-feature') {
    console.log("You're visiting a cool feature!");
  }
}

window.onhashchange = locationHashChanged;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-hashchange', 'hashchange')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.hashchange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Window/popstate_event", "popstate")}}</li>
 <li>{{domxref("WindowEventHandlers.onhashchange")}}</li>
</ul>
